---------------------------------------------------------------------------------------------------
Version: 3.2.2
Date: 2025-11-25
  Bugfixes:
    - Fixed surface exclusions for mods that are added after generating Sandboxes
    - Fixed leveling issues with synchronizing research
---------------------------------------------------------------------------------------------------
Version: 3.2.1
Date: 2025-10-24
  Bugfixes:
    - Fixed crash when pasting entities with an inventory that is too small
---------------------------------------------------------------------------------------------------
Version: 3.2.0
Date: 2025-09-22
  Changes:
    - Initial support for Space Exploration 0.7
---------------------------------------------------------------------------------------------------
Version: 3.1.0
Date: 2025-06-14
  Changes:
    - Chunks are now automatically generated while in a Sandbox
---------------------------------------------------------------------------------------------------
Version: 3.0.4
Date: 2025-06-13
  Bugfixes:
    - Stopped forcing Isolation setting on the scenario, which did not work
---------------------------------------------------------------------------------------------------
Version: 3.0.3
Date: 2025-05-12
  Bugfixes:
    - Fixed Isolation setting detection on new games
---------------------------------------------------------------------------------------------------
Version: 3.0.2
Date: 2025-04-28
  Bugfixes:
    - Fixed invalid entity alteration during search
---------------------------------------------------------------------------------------------------
Version: 3.0.1
Date: 2025-04-27
  Changes:
    - The Surfaces list is only enabled in Sandboxes when multiple non-Sandbox Surfaces exist
  Bugfixes:
    - Fixed accidental hiding of some non-Sandbox Surfaces
---------------------------------------------------------------------------------------------------
Version: 3.0.0
Date: 2025-04-27
  Changes:
    - Introducing Isolation-level setting: allows more/less integration with the rest of the game world
    - The new default Isolation is None; existing games must opt-in from the Full option
    - Infinity recipes now require one of themselves to prevent easy crafting outside of Sandboxes, just in case
    - Illusions (fake entities for working around mod incompatibilities) are no more
    - Labs can no longer be placed in Sandboxes
    - Greatly improved support for adding this mod back to a save where it had been previously removed
    - Updated icons to match similar icons from Factorio
  Bugfixes:
    - Fixed character crafting nearly infinitely in the background while Remote Viewing Sandboxes
---------------------------------------------------------------------------------------------------
Version: 2.6.4
Date: 2025-03-30
  Changes:
    - Include new Infinity Cargo Wagon
    - Stripped unnecessary alpha channels
  Bugfixes:
    - Fixed crashes when placing entities that may not have some optional information
---------------------------------------------------------------------------------------------------
Version: 2.6.3
Date: 2025-03-10
  Changes:
    - Several denied messages are printed on the player instead of the chat
    - Transitioning into the Sandbox stops the player's walking state
    - Transitioning into the Sandbox is no longer possible while driving fast
  Bugfixes:
    - Improved character re-association
    - Illusion-related warnings had an invalid periodic value and printed too often
    - Various small fixes for unexpected removals of data
---------------------------------------------------------------------------------------------------
Version: 2.6.2
Date: 2025-01-19
  Bugfixes:
    - Fix for potential asynchronous race conditions with math
---------------------------------------------------------------------------------------------------
Version: 2.6.1
Date: 2024-01-18
  Changes:
    - Updated russian translation
---------------------------------------------------------------------------------------------------
Version: 2.6.0
Date: 2025-01-17
  Changes:
    - Added a setting for Factorio to ignore surface conditions
    - New Labs will ignore surface conditions by default
    - Localised all messages printed within the game
---------------------------------------------------------------------------------------------------
Version: 2.5.4
Date: 2025-01-06
  Changes:
    - Updated and migrated Factorissimo 3 compatibility for Factorio 2.0
---------------------------------------------------------------------------------------------------
Version: 2.5.3
Date: 2024-12-23
  Changes:
    - Much simpler and more robust Equipment placement, enabled via Factorio bug-fixes
    - Equipment blueprint interactions moved from the reset button to Sandbox settings
---------------------------------------------------------------------------------------------------
Version: 2.5.2
Date: 2024-12-18
  Changes:
    - Remotely Viewing Sandboxes is now an experimental setting; God is the current default
    - Updated russian translation
---------------------------------------------------------------------------------------------------
Version: 2.5.1
Date: 2024-12-17
  Bugfixes:
    - Prevent losing Character when activating Editor Mode from the Physical Surface while Remotely Viewing a Sandbox
---------------------------------------------------------------------------------------------------
Version: 2.5.0
Date: 2024-12-17
  Changes:
    - Toggling the Sandbox now begins by Remotely Viewing it, for compatibility with more situations
    - Entering the Sandbox is still possible for the same situations it was before
    - Enabled Remote View within Sandboxs
---------------------------------------------------------------------------------------------------
Version: 2.4.0
Date: 2024-12-14
  Changes:
    - Daylight and Electrical inputs are moved into the Surface Properties GUI (now the Sandbox Settings GUI)
    - Add more Daylight and Electrical related settings
    - Removed "Chart all Labs" Setting; it's no longer optional
    - Restored Remote Views now continue following the original Entity, if any
    - Removed Space Exploration integration
---------------------------------------------------------------------------------------------------
Version: 2.3.5
Date: 2024-12-13
  Bugfixes:
    - Much better detections for entering/exiting Sandboxes
    - Special handling for Players changing Forces who haven't been seen yet
---------------------------------------------------------------------------------------------------
Version: 2.3.4
Date: 2024-12-12
  Bugfixes:
    - Trees that are actually Plants are now included in the Entity spawners
---------------------------------------------------------------------------------------------------
Version: 2.3.3
Date: 2024-12-11
  Changes:
    - Entering the Sandbox from the Editor will first attempt to close the Editor
    - Localised names for Labs
  Bugfixes:
    - Entering/Exiting the Sandbox from the Editor is usually more successful
    - Entering the Sandbox from the Remote View is usually more successful
    - Catching "escapes" from Sandbox via Remote View, to enforce the proper exit routine
---------------------------------------------------------------------------------------------------
Version: 2.3.2
Date: 2024-12-11
  Changes:
    - Entering the Sandbox from a Remote View will later return you to that same view, instead of your character
    - Prevent seeing any other Surfaces in Remote View, if within a Sandbox
  Bugfixes:
    - Remote Views won't be automatically closed for Gods or Editors, to prevent losing their inventories
---------------------------------------------------------------------------------------------------
Version: 2.3.1
Date: 2024-12-09
  Changes:
    - More Russian translations (thanks dodther)
  Bugfixes:
    - Potential fix for crashes related to invalid ghosts in Sandboxes
---------------------------------------------------------------------------------------------------
Version: 2.3.0
Date: 2024-12-02
  Changes:
    - New Scenario for an enhanced Sandbox/Editor-mode
    - Include the Turbo Loader in Sandbox items
    - Include the Heat Interface in Sandbox items
---------------------------------------------------------------------------------------------------
Version: 2.2.2
Date: 2024-12-01
  Changes:
    - Improved support for newly revived Sandbox Scenario
    - Temporary background scanning for auto-building, due to missing events
  Bugfixes:
    - Inventory management regression fixed for some cases involving volatile inventories
---------------------------------------------------------------------------------------------------
Version: 2.2.1
Date: 2024-11-26
  Changes:
    - Auto-exiting of Remote View to enter the Sandbox is possible in more cases
  Bugfixes:
    - Teleportations using Remote View work properly
    - Better detections for entering/exiting Sandboxes
    - Decreased probability of losing the player's return character when exiting Sandboxes
---------------------------------------------------------------------------------------------------
Version: 2.2.0
Date: 2024-11-23
  Changes:
    - Some Entities are available through a Selector that allows spawning them within an area
    - Tiles are available through a Selector that allows setting them within an area
    - Removed items/recipes for Tile Planners
    - Removed items/recipes for Resource Planners
---------------------------------------------------------------------------------------------------
Version: 2.1.8
Date: 2024-11-21
  Changes:
    - Maintaining icon consistency with base game
---------------------------------------------------------------------------------------------------
Version: 2.1.7
Date: 2024-11-18
  Changes:
    - Recipes intended only for the Sandboxes are now always toggled just in time
    - Item requests are now handled with the newer planning APIs
    - Failed ghost revives are added back into the queue
    - Ghost reviving queue now always runs, just in case
  Bugfixes:
    - Potentially reduced scenarios where pre-Sandbox character information is lost
---------------------------------------------------------------------------------------------------
Version: 2.1.6
Date: 2024-11-12
  Changes:
    - Cannot enter the Sandbox while using a jetpack
  Bugfixes:
    - UI now prefers to precede all others
    - Potentially resolved hidden recipes after updating while in a Sandbox
---------------------------------------------------------------------------------------------------
Version: 2.1.5
Date: 2024-11-02
  Changes:
    - Russian translations (thanks Kirill)
  Bugfixes:
    - Maximum widths for UI, to handle interactions with other mod UIs better
---------------------------------------------------------------------------------------------------
Version: 2.1.4
Date: 2024-10-31
  Bugfixes:
    - Cannot enter the Sandbox while watching any cutscenes
    - Cannot enter the Sandbox while riding a rocket
---------------------------------------------------------------------------------------------------
Version: 2.1.3
Date: 2024-10-27
  Changes:
    - A fixed Tile Planner for Empty Space, enabling more Platform-related functionality
---------------------------------------------------------------------------------------------------
Version: 2.1.2
Date: 2024-10-27
  Bugfixes:
    - Revert Tile Planner for Empty Space; pending bug reports for Factorio
---------------------------------------------------------------------------------------------------
Version: 2.1.1
Date: 2024-10-27
  Changes:
    - A new Tile Planner for Empty Space, enabling more Platform-related functionality
  Bugfixes:
    - Internal recipes no longer show up for selections of signals
    - Other Platforms are no longer visible from the Sandboxes
---------------------------------------------------------------------------------------------------
Version: 2.1.0
Date: 2024-10-26
  Changes:
    - Resource/Lab Planners are no longer items leftover in your inventory
    - Surface properties are editable in a new GUI to enable/disable some recipes
---------------------------------------------------------------------------------------------------
Version: 2.0.1
Date: 2024-10-22
  Bugfixes:
    - Spilling items from inventory was not working
---------------------------------------------------------------------------------------------------
Version: 2.0.0
Date: 2024-10-21
  Changes:
    - Updated for Factorio 2.0
    - Planner for replacing Lab Tiles
    - Alternative Lab Tiles
    - More generic support for Tiles that produce Fluids
    - GUI for the Global Electric Network
---------------------------------------------------------------------------------------------------
Version: 1.19.1
Date: 2024-07-06
  Changes:
    - Factorissimo2 marked as incompatible; the factorissimo-2-notnotmelon is the only supported variant
---------------------------------------------------------------------------------------------------
Version: 1.19.0
Date: 2024-04-13
  Changes:
    - Lab-based Sandboxes can slowly absorb Pollution
    - Start-up Setting for Lab Pollution absorption
---------------------------------------------------------------------------------------------------
Version: 1.18.0
Date: 2024-03-24
  Changes:
    - Auto-building in the Sandbox is now a Setting
  Bugfixes:
    - Remote Interface detection was not working
---------------------------------------------------------------------------------------------------
Version: 1.17.1
Date: 2024-01-09
  Changes:
    - Neutral Entities in Sandboxes are now considered the same as those belonging to the Sandbox Force
  Bugfixes:
    - Items on the ground in Sandboxes were not being destroyed when marked for deconstruction
---------------------------------------------------------------------------------------------------
Version: 1.17.0
Date: 2024-01-03
  Changes:
    - A Player changing Forces now has their Sandbox Entities assigned to the new Force
---------------------------------------------------------------------------------------------------
Version: 1.16.8
Date: 2023-11-07
  Bugfixes:
    - Another potential startup crash from last release
---------------------------------------------------------------------------------------------------
Version: 1.16.7
Date: 2023-11-07
  Bugfixes:
    - Startup crash from last release
---------------------------------------------------------------------------------------------------
Version: 1.16.6
Date: 2023-11-06
  Changes:
    - Editor Extensions' Lab setting is forcefully disabled due to compatibility issues
  Bugfixes:
    - Updated support for Editor Extensions' Recipes in the Sandbox
---------------------------------------------------------------------------------------------------
Version: 1.16.5
Date: 2023-10-31
  Changes:
    - Support for ignoring Smarter Inserter's temporary Entities
---------------------------------------------------------------------------------------------------
Version: 1.16.4
Date: 2023-07-30
  Changes:
    - Necessary updates for 1.16.0 and Factorio 1.1.87: large refactor of Equipment Blueprint placement
---------------------------------------------------------------------------------------------------
Version: 1.16.3
Date: 2023-07-08
  Bugfixes:
    - Regression fix when leaving a Lab into a non-Character controller
---------------------------------------------------------------------------------------------------
Version: 1.16.2
Date: 2023-07-02
  Bugfixes:
    - Crash when deleting Labs
---------------------------------------------------------------------------------------------------
Version: 1.16.1
Date: 2023-06-15
  Bugfixes:
    - Potential crashes and incorrect Sandbox surface generation when paired with mods such as RSO caused by 1.15
---------------------------------------------------------------------------------------------------
Version: 1.16.0
Date: 2023-06-10
  Changes:
    - Illusion replacements of Container-based Entities are now Infinity Containers
  Bugfixes:
    - Some much older versions of this mod would crash in a rare scenario when loading a recent version
---------------------------------------------------------------------------------------------------
Version: 1.15.0
Date: 2023-06-02
  Changes:
    - Blueprints can be provided as the default Equipment to be used when Resetting each Sandbox
  Bugfixes:
    - script_raised_built is now handled like on_built_entity
---------------------------------------------------------------------------------------------------
Version: 1.14.0
Date: 2023-05-30
  Changes:
    - Blueprints can be brought into and out of the Sandbox via the Cursor (in most cases)
---------------------------------------------------------------------------------------------------
Version: 1.13.0
Date: 2023-05-28
  Changes:
    - Lab speed within Sandboxes is now a setting
---------------------------------------------------------------------------------------------------
Version: 1.12.2
Date: 2023-04-30
  Changes:
    - Large performance improvements when paired with Factorissimo2, courtesy of undermark5
---------------------------------------------------------------------------------------------------
Version: 1.12.1
Date: 2023-01-07
  Changes:
    - Adding a warning for selecting new contents for a Blueprint in your Blueprint Library, since Factorio does not allow mods to handle this situation
  Bugfixes:
    - Selecting new contents for a Blueprint in your Inventory was not always replacing Illusions with Real Entities
---------------------------------------------------------------------------------------------------
Version: 1.12.0
Date: 2023-01-04
  Changes:
    - The "Extra Mining Speed" applied in Sandboxes is now a Runtime Setting
---------------------------------------------------------------------------------------------------
Version: 1.11.5
Date: 2023-01-03
  Bugfixes:
    - Tapelines were sometimes auto-built which prevents the intended use
---------------------------------------------------------------------------------------------------
Version: 1.11.4
Date: 2023-01-02
  Bugfixes:
    - Logistic Train Stop Inputs/Outputs were sometimes auto-built resulting in circuit network issues
---------------------------------------------------------------------------------------------------
Version: 1.11.3
Date: 2022-12-30
  Bugfixes:
    - Crash after Space Exploration deletes a Surface that was used by this mod
    - Crash after a Space Exploration update from 0.5 to 0.6 and certain Entities were used inside a Sandbox
---------------------------------------------------------------------------------------------------
Version: 1.11.2
Date: 2022-11-22
  Changes:
    - Illusions no longer appear in the "Made in" tooltips
  Bugfixes:
    - Crash when Ghost-building an Illusion over an Illusion
---------------------------------------------------------------------------------------------------
Version: 1.11.1
Date: 2022-11-09
  Changes:
    - dangOreus will ignore any created Sandbox Surfaces
---------------------------------------------------------------------------------------------------
Version: 1.11.0
Date: 2022-10-31
  Changes:
    - New Illusions framework: Entities that are swapped to cardboard-cutouts inside of Sandboxes to avoid issues or cheating
    - Nearly all script-driven Space Exploration Entities are now Illusions in the Sandboxes
---------------------------------------------------------------------------------------------------
Version: 1.10.1
Date: 2022-09-04
  Changes:
    - Moons within the Calidus system and Moons with Threats are no longer chosen for Planetary Sandboxes. Existing Planetary Sandboxes fitting this criteria will be destroyed
    - Performance improvements related to some cases of creating Entities with the Factorissimo integration
  Bugfixes:
    - Crash when something other than this mod lets the Planer enter then leave a Sandbox
---------------------------------------------------------------------------------------------------
Version: 1.10.0
Date: 2022-08-23
  Changes:
    - Asynchronous Sandbox Operations are now maintained in an internal Queue
    - Factorissimo Factories within Sandboxes are treated similarly to Sandboxes
  Bugfixes:
    - Crash with a combination of entering/existing Factorissimo Factories within Sandboxes
    - Crash after renaming or deleting certain Surfaces in the middle of asynchronous operations
---------------------------------------------------------------------------------------------------
Version: 1.9.3
Date: 2022-08-08
  Bugfixes:
    - Adding Mods that alter Research would not be accounted for in the Sandbox
---------------------------------------------------------------------------------------------------
Version: 1.9.2
Date: 2022-07-29
  Bugfixes:
    - Non-Admins could not set Filters on Infinity Chests/Pipes
---------------------------------------------------------------------------------------------------
Version: 1.9.0
Date: 2022-07-23
  Changes:
    - Proxy chats between Players inside Sandboxes and those outside of Sandboxes
  Bugfixes:
    - Space Exploration Core Seams are not exposed as Resource Planners in <= 0.5
---------------------------------------------------------------------------------------------------
Version: 1.8.3
Date: 2022-07-23
  Changes:
    - Space Exploration Core Seams are now exposed as Resource Planners
    - Creations in Sandboxes are no longer async by default, since Factorio 1.1.61
  Bugfixes:
    - Crash with 1.6.x versions of Space Exploration
---------------------------------------------------------------------------------------------------
Version: 1.8.2
Date: 2022-06-24
  Bugfixes:
    - Crash when combined with other mods that remove some Autoplace Controls from Nauvis
---------------------------------------------------------------------------------------------------
Version: 1.8.1
Date: 2022-06-16
  Bugfixes:
    - Crash when starting a new game
---------------------------------------------------------------------------------------------------
Version: 1.8.0
Date: 2022-06-15
  Changes:
    - New Setting to prevent non-Admins from Resetting Force-wide Sandboxes in Multiplayer games
---------------------------------------------------------------------------------------------------
Version: 1.7.4
Date: 2022-06-13
  Bugfixes:
    - The migration for 1.7.3 wasn't always applied
    - The Unlock-all-Technology setting was sometimes reverting gained bonuses
---------------------------------------------------------------------------------------------------
Version: 1.7.3
Date: 2022-05-30
  Bugfixes:
    - The Daylight Slider icon was mistakenly sending a Click Event
---------------------------------------------------------------------------------------------------
Version: 1.7.2
Date: 2022-05-29
  Bugfixes:
    - Crash when adding this mod back to a save after having removed it
---------------------------------------------------------------------------------------------------
Version: 1.7.1
Date: 2022-05-19
  Bugfixes:
    - The default Resource Planner density is much larger
---------------------------------------------------------------------------------------------------
Version: 1.7.0
Date: 2022-05-17
  Changes:
    - New Tile Planners for creating Tiles that might not otherwise be possible, only within Sandboxes
    - New daylight slider within Sandboxes to alter the daytime on the Sandbox Surface
    - Performance improvements related to any built Entities
  Bugfixes:
    - When paired with Editor Extensions, if Cheat Mode was already enabled outside of the Sandboxes, it would not be "re-enabled" within the Sandboxes, preventing the use of the additional Recipes within Sandboxes
---------------------------------------------------------------------------------------------------
Version: 1.6.1
Date: 2022-04-25
  Changes:
    - Resource Planners consider the Map Generator's Richness and Resource-specific values when determining how much to place
    - Resource Planners consider the Bounding Box of the Resource when determining how often to place
---------------------------------------------------------------------------------------------------
Version: 1.6.0
Date: 2022-05-03
  Changes:
    - Last-known-Positions within Sandboxes are persisted so that they can be returned to when swapping between Sandboxes and other Surfaces
    - Cheat-mode is toggled between the previous state and true, instead of reverting back to false
    - Players that are toggled into the Map Editor can no longer enter a Sandbox (otherwise their original Character would be lost)
    - Non-Character Inventories are persisted so that they can be restored when exiting a Sandbox
  Bugfixes:
    - Removed Players wouldn't clean up their Persistent Inventories
---------------------------------------------------------------------------------------------------
Version: 1.5.1
Date: 2022-04-25
  Changes:
    - Craft-to-Cursor is smarter about exactly which Item ends up in the Cursor for Recipes with multiple Products
  Bugfixes:
    - Crafting a Recipe in a Sandbox that produces a Liquid would crash
---------------------------------------------------------------------------------------------------
Version: 1.5.0
Date: 2022-04-21
  Changes:
    - Bonus Inventory Slots for Sandboxes Setting
    - Prevent Sandbox Inventories from becoming full by spilling their last slot
    - Provide a "Trash can" in new Sandboxes
---------------------------------------------------------------------------------------------------
Version: 1.4.2
Date: 2022-04-18
  Bugfixes:
    - Ghosting certain Entities with Modules into a Space-based Sandbox could crash
---------------------------------------------------------------------------------------------------
Version: 1.4.1
Date: 2022-04-17
  Bugfixes:
    - Level-based Research wasn't correctly synchronized
---------------------------------------------------------------------------------------------------
Version: 1.4.0
Date: 2022-04-16
  Changes:
    - Loaders will only be "owned" by this Mod if no other Mod has already activated them in the data stage
    - More Item Requests can be automatically handled within Sandboxes
  Bugfixes:
    - Entering a Sandbox with the Editor Extensions Mod loaded would give the Player too many capabilities outside of the Sandbox (but not within)
---------------------------------------------------------------------------------------------------
Version: 1.3.0
Date: 2022-04-15
  Changes:
    - Craft-to-Cursor is now a Player Mod Setting
---------------------------------------------------------------------------------------------------
Version: 1.2.0
Date: 2022-04-12
  Changes:
    - The Research Queue for Sandboxes mimics the real Research Queue
---------------------------------------------------------------------------------------------------
Version: 1.1.1
Date: 2022-04-10
  Bugfixes:
    - New games beginning with a Cutscene would crash
---------------------------------------------------------------------------------------------------
Version: 1.1.0
Date: 2022-04-08
  Changes:
    - The Inventory within Sandboxes is now persisted
---------------------------------------------------------------------------------------------------
Version: 1.0.3
Date: 2022-04-05
  Changes:
    - The Space Exploration Planetary Lab now uses a Moon instead of a Star
    - Existing Space Exploration Planetary Labs will be deleted
  Bugfixes:
    - Passengers in Rockets that are launched while the Player is inside a Sandbox would crash
    - Various fixes related to the Space Exploration Planetary Lab
---------------------------------------------------------------------------------------------------
Version: 1.0.2
Date: 2022-04-03
  Bugfixes:
    - The Sandbox Force could have become out-of-sync with its original Force
---------------------------------------------------------------------------------------------------
Version: 1.0.1
Date: 2022-04-02
  Bugfixes:
    - Placing Blueprints with Tiles in a Planetary Lab would revert the Tiles to Empty Space
---------------------------------------------------------------------------------------------------
Version: 1.0.0
Date: 2022-03-29
  Changes:
    - Initial Release
  Bugfixes:
    - None
